<app-loading *ngIf="isLoadingPage"></app-loading>
<div class="btnAcrossPageName">
  <!-- add -->
  <mb-button mbButtonSize='MEDIUM' mbButtonAvailableStyle='ADD_NEW' (click)='doPrepareInserOrUpdate()'
             mbButtonText="{{'staffAbs.approvalFlow.insert' | translate}}" *ngIf="objFunction.edit"></mb-button>

  <mb-button
    mbButtonSize="MEDIUM"
    mbButtonAvailableStyle="IMPORT"
    *ngIf="objFunction.edit"
    (click)="doOpenImport()"
    mbButtonText="{{'common.upload.upload' | translate}}"
  >
  </mb-button>
  <mb-button class='button__class--no-padding button__class--no-margin' mbButtonType="NO_BORDER" mbButtonSize="LARGE"
             mbButtonBgColor="transparent" mbButtonText="" *ngIf="!objFunction.edit">
  </mb-button>
</div>


<div class="content__item content__item--border bg__content--default">
  <!-- search form -->
  <form nz-form [formGroup]='formSearch' style='margin-bottom: 8px' (keyup.enter)='doSearch()'>
    <div nz-row [nzGutter]='[30,30]'>
      <div nz-col [nzXs]='24' [nzLg]='6'>
        <mb-select [mbDataSelects]='listEmpType'
                   mbKeyLabel='label'
                   mbKeyValue='value'
                   [mbErrorDefs]="[{ errorName: 'required', errorDescription: 'staffAbs.validate.required' | translate: {'param': 'staffAbs.workHisInformation.label.attributes.empType' | translate}}]"
                   mbPlaceholder="--{{'staffAbs.workHisInformation.label.attributes.empType' | translate}}--"
                   mbLabelText="{{'staffAbs.workHisInformation.label.attributes.empType' | translate}}"
                   formControlName='empTypeCode'
        ></mb-select>
    </div>
    <div nz-col [nzXs]='24' [nzLg]='6'>
      <mb-input-text formControlName='keySearch' [mbMaxLength]='200'
        mbPlaceholderText="--{{'staffAbs.label.keySearchEmployee' | translate}}--"
        mbLabelText="{{'staffAbs.label.keySearchEmployee' | translate}}"></mb-input-text>
    </div>
    <div nz-col [nzXs]="24" [nzLg]="6">
      <org-data-picker mbLabelText="{{'staffAbs.timekeepingManagement.organizationId' | translate}}"
        mbPlacholder="--{{'staffAbs.timekeepingManagement.organizationIdSearch' | translate }}--"
        [functionCode]="functionCode" [scope]="scope" formControlName="organizationId"></org-data-picker>
    </div>
      <div nz-col [nzXs]="24" [nzLg]="6">
        <mb-select-check-able
                    [mbShowAction]="false"
                    [mbDataSelects]="EMP_STATUS_DATASOURCE"
                    formControlName="empStatus"
                    mbPlaceholder="{{'staffAbs.label.empStatus' | translate }}"
                    mbLabelText="{{'staffAbs.label.empStatus' | translate}}"
                ></mb-select-check-able>
      </div>       
      <div nz-col [nzXs]='24' [nzLg]='6'>
        <mb-date-picker mbPlaceholderText="--{{'staffAbs.timekeepingManagement.fromTime' | translate}}--"
          mbLabelText="{{'staffAbs.timekeepingManagement.fromTime' | translate}} " formControlName="fromTime">
        </mb-date-picker>
      </div>
      <div nz-col [nzXs]='24' [nzLg]='6'>
        <mb-date-picker mbPlaceholderText="--{{'staffAbs.timekeepingManagement.toTime' | translate}}--"
          mbLabelText="{{'staffAbs.timekeepingManagement.toTime' | translate}} " formControlName="toTime"
          [mbType]=" formSearch.errors ? 'error' : 'default'" [mbShowError]="formSearch.errors !== null"
          [mbErrors]="formSearch.errors"
          [mbErrorDefs]="[ { errorName: 'rangeDateError', errorDescription: 'staffAbs.timekeepingManagement.rangeDateEqualError' | translate} ]">
        </mb-date-picker>
      </div>
      <div nz-col [nzXs]='24' nzLg='6'>
        <mb-select-check-able
            [mbShowAction]="false"
            [mbDataSelects]="REQUEST_STATUS_APPROVAL_DATA_SOURCE"
            formControlName="listStatus"
            mbPlaceholder="{{'staffAbs.timekeepingManagement.approvalStatus' | translate }}"
            mbLabelText="{{'staffAbs.timekeepingManagement.approvalStatus' | translate}}"
        ></mb-select-check-able>
      </div>
    </div>
  </form>

  <div nz-row class="btn__row">
    <div nz-col nzSpan="8"></div>

    <div nz-col nzSpan="8">
      <div style="text-align: center">
        <mb-button
          class="staff__research__btn__search"
          mbButtonSize="MEDIUM"
          mbButtonAvailableStyle="SEARCH"
          (click)='doSearch()'
          mbButtonText="{{'staffAbs.label.search' | translate}}"
        ></mb-button>
        <mb-button
          mbButtonSize="MEDIUM"
          mbButtonType="BORDER"
          (click)='doExport(fileNameExport)'
        >
          <img src="/assets/icon/staff-manager/export_excel.svg" alt=""/>
        </mb-button>
      </div>
    </div>
    <div nz-col nzSpan="8"></div>
  </div>
</div>

<!-- search list -->
<div class='search__result'>
  <mb-table-wrap>
    <mb-table (changePageNum)='doSearch($event)' [tableConfig]='tableConfig' [tableData]='searchResult'></mb-table>
  </mb-table-wrap>
</div>

<!-- template action -->
<ng-template #actionTmpl let-requestId='requestId' let-status="status">
  <mb-button *ngIf="!NOT_ALLOW_EDIT.includes(status)" mbButtonType="ONLY_ICON" mbButtonIconType="AWESOME" mbPrefixIcon="far fa-pencil-alt"
    (click)="doPrepareInserOrUpdate(requestId)"></mb-button>
  <mb-button  *ngIf='objFunction.correction && (status === REQUEST_STATUS.WAIT_APPROVE_BACKDATE || status === REQUEST_STATUS.CANCEL_BACKDATE)'  mbButtonType="ONLY_ICON" mbButtonIconType="AWESOME" nz-popconfirm
    nzPopconfirmTitle="{{'staffAbs.table.action.confirmApproveBackdate' | translate}}"
    nzCancelText="{{'staffAbs.table.action.cancel' | translate}}" nzOkType="primary"
    nzOkText="{{'staffAbs.table.action.yes' | translate}}" (nzOnConfirm)="doApproveBackdate(requestId)"
    nzPopconfirmPlacement="top" mbPrefixIcon="fal fa-check"></mb-button>
    <!-- Tu choi xet duyet backdate -->
    <mb-button *ngIf='objFunction.correction && (status === REQUEST_STATUS.WAIT_APPROVE_BACKDATE || status === REQUEST_STATUS.CANCEL_BACKDATE)' mbButtonType="ONLY_ICON" mbButtonIconType="AWESOME" mbPrefixIcon="far fa-times"
      (click)="doPrepareReject(requestId, footerRejectTmpl)"></mb-button>
    <mb-button *ngIf="!NOT_ALLOW_DELETE.includes(status)" mbButtonType="ONLY_ICON" mbButtonIconType="AWESOME" nz-popconfirm
    nzPopconfirmTitle="{{'staffAbs.table.action.confirmDelete' | translate}}"
    nzCancelText="{{'staffAbs.table.action.cancel' | translate}}" nzOkType="primary"
    nzOkText="{{'staffAbs.table.action.yes' | translate}}" (nzOnConfirm)="doDelete(requestId)"
    nzPopconfirmPlacement="top" mbPrefixIcon="fal fa-trash-alt"></mb-button>
</ng-template>

<!-- Modal thêm / sửa -->

<!-- Modal import -->
<import-request [isRequiredFileAttach]="true" [showContent]='isImportData' (onCloseModal)='doCloseImport($event)' [leaveType]='TRAINING'></import-request>

<ng-template #filesTmpl let-files='files'>
  <div *ngFor="let file of files">
    <a (click)="downloadFile(file)"> {{file.fileName}}</a>
  </div>
</ng-template>


<ng-template #statusTmpl let-status='status'>
  <nz-tag [nzColor]="TAG.STATUS_DRAFT" *ngIf='status === REQUEST_STATUS.DRAFT || !status'>{{ getStatus(status ?? 0)}}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_WAIT_APPROVE" *ngIf='status === REQUEST_STATUS.WAIT_APPROVE'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_APPROVED" *ngIf='status === REQUEST_STATUS.APPROVED'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_REJECT" *ngIf='status === REQUEST_STATUS.REJECT'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_REQUEST_CANCEL" *ngIf='status === REQUEST_STATUS.REQUEST_CANCEL'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_CANCEL" *ngIf='status === REQUEST_STATUS.CANCEL'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_AJUST" *ngIf='status === REQUEST_STATUS.AJUST'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_WAIT_APPROVE" *ngIf='status === REQUEST_STATUS.WAIT_APPROVE_BACKDATE'>{{ getStatus(status) }}</nz-tag>
  <nz-tag [nzColor]="TAG.STATUS_WAIT_APPROVE" *ngIf='status === REQUEST_STATUS.CANCEL_BACKDATE'>{{ getStatus(status) }}</nz-tag>
</ng-template>

<!-- Footer Tu choi phe duyet backdate -->
<ng-template #footerRejectTmpl>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal?.destroy()" mbButtonBgColor="transparent"
    mbButtonText="{{'common.button.cancel' | translate}}"></mb-button>
  <mb-button mbButtonType="NO_BORDER" mbButtonSize="LARGE" (click)="modal?.getContentComponent().save()"
    mbButtonAvailableStyle="PRIMARY" mbButtonText="{{'common.button.save' | translate}}"></mb-button>
</ng-template>